include "Zeropage.inc"

tempo equ 180/4
tempo_denom equ 600/4


count equ 3
Ch_Ptr equ 0
Ch_Start equ Ch_Ptr+2
Ch_Cycle equ Ch_Start+2
Ch_Len equ Ch_Cycle+2
Ch_Bits equ Ch_Len+1
unitSize equ Ch_Bits+1

Bit_voice equ $01
Bit_prior equ $02

dseg
Channels: public Channels
    defs unitSize*count
time: defb 0
block: defb 0

Channel0 equ Channels
Channel1 equ Channels+unitSize
Channel2 equ Channels+unitSize*2

cseg
tedTable: ; lo, hi, bit(#2)
    defb 14,18,$20
    defb 15,16,$10

InitSound: public InitSound
    ldx #0
    ldy #count
    do
        lda #0
        sta Channels+Ch_Ptr,x
        sta Channels+Ch_Ptr+1,x
        sta Channels+Ch_Cycle,x
        sta Channels+Ch_Cycle+1,x
        txa | clc | adc #unitSize | tax
        dey
    while ne | wend

    lda #0
    sta time
    sta block
    
    lda #Bit_prior or 1 | sta Channel0+Ch_Bits
    lda #1 | sta Channel1+Ch_Bits
    lda #0 | sta Channel2+Ch_Bits

    lda #$08 | sta $ff00+17
rts


pScore equ ZW0

cseg
Mute:
    lda #0
    sta Channels+Ch_Cycle,x
    sta Channels+Ch_Cycle+1,x

    lda Channels+Ch_Bits,x
    lsr a
    if cc
        lda $ff00+17 | and #not $10 | sta $ff00+17
    else
        tay
            lda $ff00+17 | and #not $20 | sta $ff00+17
        tya
        lsr a
        if cc
            lda block
            if eq
                lda Channel1+Ch_Cycle
                ora Channel1+Ch_Cycle+1
                if ne
                    lda Channel1+Ch_Cycle | sta $ff00+15
                    lda Channel1+Ch_Cycle,x | sta $ff00+16
                    lda $ff00+17 | ora #$20 | sta $ff00+17
                    rts
                endif
            endif
        endif
    endif
rts


SoundHandler: public SoundHandler
    lda <pScore+0 | pha
    lda <pScore+1 | pha
        lda time
        sec | sbc #tempo
        sta time
        if cc
            ldx #0
            do
                lda Channels+Ch_Ptr,x
                ora Channels+Ch_Ptr+1,x
                if ne
                    dec Channels+Ch_Len,x
                    if eq
                        continue:
                        lda Channels+Ch_Ptr,x | sta <pScore+0
                        lda Channels+Ch_Ptr+1,x | sta <pScore+1
                        ldy #0 | lda (<pScore),y
                        if eq
                            ; end
                            jsr Mute
                            lda #0
                            sta Channels+Ch_Ptr,x
                            sta Channels+Ch_Ptr+1,x
                            lda Channels+Ch_Bits,x
                            and #Bit_prior
                            if ne
                                lda #0 | sta block
                            endif
                            jmp next
                        endif
                        cmp #$ff
                        if eq
                            ; repeat
                            lda Channels+Ch_Start,x
                            sta Channels+Ch_Ptr,x
                            lda Channels+Ch_Start+1,x
                            sta Channels+Ch_Ptr+1,x
                            jmp continue
                        endif
                        sta Channels+Ch_Len,x
                        iny | lda (<pScore),y
                        if ne
                            sec | sbc #1
                            asl a
                            tay
                            lda cycles,y | sta Channels+Ch_Cycle,x
                            lda cycles+1,y | sta Channels+Ch_Cycle+1,x
                            lda Channels+Ch_Bits,x
                            lsr a
                            if cc
                                lda Channels+Ch_Cycle,x | sta $ff00+14
                                lda $ff00+18
                                and #$fc 
                                ora Channels+Ch_Cycle+1,x | sta $ff00+18
                                lda $ff00+17 | ora #$10 | sta $ff00+17
                            else
                                lsr a
                                if cc
                                    lda block
                                    bne EndWriteCycle
                                else
                                    lda #1 | sta block
                                endif
                                lda #0 | sta block
                                lda Channel1+Ch_Cycle
                                ora Channel1+Ch_Cycle+1
                                if ne
                                    lda $ff00+17 | and #not $20 | sta $ff00+17
                                endif
                                lda Channels+Ch_Cycle,x | sta $ff00+15
                                lda Channels+Ch_Cycle+1,x | sta $ff00+16
                                lda $ff00+17 | ora #$20 | sta $ff00+17
                            endif
                            skip:
                        else
                            jsr Mute
                        endif
                        EndWriteCycle:
                        lda Channels+Ch_Ptr,x | clc | adc #2 | sta Channels+Ch_Ptr,x
                        lda Channels+Ch_Ptr+1,x | adc #0 | sta Channels+Ch_Ptr+1,x
                    endif
                endif
                next:
                txa | clc | adc #unitSize | tax
                cpx #count*unitSize
            while ne | wend
            lda time
            clc | adc #tempo_denom
            sta time
        endif
    pla | sta <pScore+1
    pla | sta <pScore+0
rts

Melody:
    pha
        lda Channel0+Ch_Ptr
        ora Channel0+Ch_Ptr+1
        if eq
            jsr MelodyPrior
        endif
    pla
rts

MelodyPrior:
    pha
        sei
            sty Channel0+Ch_Ptr
            stx Channel0+Ch_Ptr+1
            lda #1
            sta Channel0+Ch_Len
        cli
    pla
rts

MelodyWait:
    jsr MelodyPrior
    pha
        do
            lda Channel0+Ch_Ptr
            ora Channel0+Ch_Ptr+1
        while ne | wend
    pla
rts


; void Sound_Loose();
loose_notes:
    defb 1,C4, 0
Sound_Loose_: public Sound_Loose_
    ldy #low loose_notes
    ldx #high loose_notes
jmp MelodyWait


; void Sound_Hit();
hit_notes:
    defb 1,F4, 1,G4, 1,A4, 1,B4, 1,C5, 1,D5, 1,E5, 1,F5
    defb 0
Sound_Hit_: public Sound_Hit_
    ldy #low hit_notes
    ldx #high hit_notes
jmp Melody


; void Sound_Beep();
beep_notes:
    defb 1,A4, 0
Sound_Beep_: public Sound_Beep_
    ldy #low beep_notes
    ldx #high beep_notes
jmp MelodyWait


; void Sound_Bonus();
bonus_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Bonus_: public Sound_Bonus_
    ldy #low bonus_notes
    ldx #high bonus_notes
jmp MelodyWait


; void Sound_Start();
start_notes:
	defb 11,C4,1,0, 11,E4,1,0
	defb 5,G4,1,0, 11,E4,1,0, 11,F4,1,0
	defb 5,F4,1,0, 11,A4,1,0, 5,C5,1,0
	defb 17,A4,1,0, 31,C5,5,0
	defb 12,0
    defb 0
Sound_Start_: public Sound_Start_
    ldy #low start_notes
    ldx #high start_notes
jmp MelodyWait


; void Sound_Clear();
clear_notes:
	defb 5,A4,1,0, 5,A4,1,0, 5,G4,1,0, 5,F4,1,0
	defb 5,G4,1,0, 11,A4,1,0, 11,B4,1,0
	defb 5,B4,1,0, 5,A4,1,0, 5,G4,1,0, 5,A4,1,0
	defb 11,B4,1,0, 29,C5,1,0
	defb 24,0
    defb 0
Sound_Clear_: public Sound_Clear_
    ldy #low clear_notes
    ldx #high clear_notes
jmp MelodyWait


; void Sound_GameOver();
over_notes: 
	defb 5,C5,1,0, 5,F4,1,0, 5,A4,1,0, 5,E4,1,0
	defb 5,G4,1,0, 5,A4,1,0, 5,B4,1,0, 5,C5,1,0
	defb 31,C5,5,0
	defb 12,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    ldy #low over_notes
    ldx #high over_notes
jmp MelodyWait


BGM_B:
	defb 11,C4,1,0, 11,G4,1,0
	defb 5,C4,1,0, 11,G4,1,0, 11,A4,1,0
	defb 5,A4,1,0, 5,G4,1,0, 5,G4,1,0, 5,F4,1,0
	defb 5,F4,1,0, 5,E4,1,0, 5,E4,1,0, 11,D4,1,0
	defb 11,D4,1,0, 5,D4,1,0, 11,E4,1,0
	defb 17,D4,1,0, 36,0
	defb 11,C4,1,0, 11,G4,1,0
	defb 5,C4,1,0, 11,G4,1,0, 11,A4,1,0
	defb 5,A4,1,0, 5,G4,1,0, 5,G4,1,0, 5,F4,1,0
	defb 5,F4,1,0, 5,E4,1,0, 5,E4,1,0, 11,F4,1,0
	defb 11,F4,1,0, 5,F4,1,0, 11,A4,1,0
	defb 17,G4,1,0, 36,0
	defb 5,E4,1,0, 5,E4,1,0, 5,E4,1,0, 11,E4,1,0
	defb 5,E4,1,0, 11,A4,1,0, 5,D4,1,0
	defb 5,D4,1,0, 5,D4,1,0, 11,D4,1,0
	defb 5,D4,1,0, 11,G4,1,0, 6,0
	defb 5,A4,1,0, 6,0, 5,G4,1,0, 6,0
	defb 5,F4,1,0, 6,0, 5,E4,1,0, 11,D4,1,0
	defb 11,E4,1,0, 23,C4,1,0
    defb $ff

BGM_C:
	defb 5,C3,1,0, 12,0, 17,E3,1,0
	defb 5,G3,1,0, 6,0, 5,A2,1,0, 12,0
	defb 17,C3,1,0, 5,E3,1,0
	defb 6,0, 5,D3,1,0, 12,0
	defb 17,F3,1,0, 5,A3,1,0
	defb 6,0, 5,G3,1,0, 12,0
	defb 17,B2,1,0, 5,D3,1,0
	defb 6,0, 5,C3,1,0, 12,0
	defb 17,E3,1,0, 5,G3,1,0
	defb 6,0, 5,A2,1,0, 12,0
	defb 17,C3,1,0, 5,E3,1,0
	defb 6,0, 5,F3,1,0, 12,0
	defb 5,F3,1,0, 5,G3,1,0, 12,0
	defb 5,G3,1,0, 5,C3,1,0, 12,0
	defb 17,E3,1,0, 5,G3,1,0
	defb 6,0, 5,C3,1,0, 12,0
	defb 5,C3,1,0, 5,A2,1,0, 12,0
	defb 5,A2,1,0, 5,D3,1,0, 12,0
	defb 5,D3,1,0, 5,G3,1,0, 12,0
	defb 5,G3,1,0, 6,0, 5,F3,1,0, 6,0
	defb 5,F3,1,0, 6,0, 5,G3,1,0, 6,0
	defb 5,G3,1,0, 5,C3,1,0, 12,0
	defb 17,E3,1,0, 5,G3,1,0
	defb 6,0
    defb $ff


; void StartBGM();
StartBGM_: public StartBGM_
    sei
        lda #low BGM_B
        sta Channel1+Ch_Start
        sta Channel1+Ch_Ptr
        lda #high BGM_B
        sta Channel1+Ch_Start+1
        sta Channel1+Ch_Ptr+1
        lda #1
        sta Channel1+Ch_Len
        
        lda #low BGM_C
        sta Channel2+Ch_Start
        sta Channel2+Ch_Ptr
        lda #high BGM_C
        sta Channel2+Ch_Start+1
        sta Channel2+Ch_Ptr+1
        lda #1
        sta Channel2+Ch_Len
    cli
rts


; void StopBGM();
StopBGM_: public StopBGM_
    sei
        lda #0
        sta Channel1+Ch_Ptr
        sta Channel1+Ch_Ptr+1
        sta Channel2+Ch_Ptr
        sta Channel2+Ch_Ptr+1

        lda $ff00+17 | and #not $30 | sta $ff00+17
    cli
rts


N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2
N16 equ N8/2


A2 equ 1
A2S equ 2
B2 equ 3
C3 equ 4
C3S equ 5
D3 equ 6
D3S equ 7
E3 equ 8
F3 equ 9
F3S equ 10
G3 equ 11
G3S equ 12
A3 equ 13
A3S equ 14
B3 equ 15
C4 equ 16
C4S equ 17
D4 equ 18
D4S equ 19
E4 equ 20
F4 equ 21
F4S equ 22
G4 equ 23
G4S equ 24
A4 equ 25
A4S equ 26
B4 equ 27
C5 equ 28
C5S equ 29
D5 equ 30
D5S equ 31
E5 equ 32
F5 equ 33
F5S equ 34
G5 equ 35

cycles:
defw 7 ; A2
defw 64 ; A#2
defw 118 ; B2
defw 169 ; C3
defw 217 ; C#3
defw 262 ; D3
defw 305 ; D#3
defw 345 ; E3
defw 383 ; F3
defw 419 ; F#3
defw 453 ; G3
defw 485 ; G#3
defw 516 ; A3
defw 544 ; A#3
defw 571 ; B3
defw 596 ; C4
defw 620 ; C#4
defw 643 ; D4
defw 664 ; D#4
defw 685 ; E4
defw 704 ; F4
defw 722 ; F#4
defw 739 ; G4
defw 755 ; G#4
defw 770 ; A4
defw 784 ; A#4
defw 798 ; B4
defw 810 ; C5
defw 822 ; C#5
defw 834 ; D5
defw 844 ; D#5
defw 854 ; E5
defw 864 ; F5
defw 873 ; F#5
defw 881 ; G5
